// **************************************************************************************
// *
// * © 2012 Dell, Inc.
// * ALL RIGHTS RESERVED.
// *
// * Redistribution and use in source and binary forms, with or without modification, 
// * are permitted provided that the following conditions are met:
// * 
// *  *  Redistributions of source code must retain the above copyright notice, 
// *     this list of conditions and the following disclaimer.  
// * 
// *  *  Redistributions in binary form must reproduce the above copyright notice, 
// *     this list of conditions and the following disclaimer in the documentation 
// *     and/or other materials provided with the distribution.  
// * 
// *  *  Neither the name of Dell, Inc. nor the names of its contributors 
// *     may be used to endorse or promote products derived from this software 
// *     without specific prior written permission. 
// * 
// * 
// * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
// * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
// * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
// * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
// * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
// * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
// * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
// * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
// * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// * 
// **************************************************************************************

#include <syslog.h>

#include "mainaboutdialog.h"
#include "ui_mainaboutdialog.h"


MainAboutDialog::MainAboutDialog(QWidget *parent) :
    CommonDialog(parent),
    ui(new Ui::MainAboutDialog)
{
    ui->setupUi(this);

    setWindowFlags(Qt::FramelessWindowHint | Qt::Dialog);
    setWindowMask( "", width() -11, height() -11);

    ui->helpFrame->hide();
}

MainAboutDialog::~MainAboutDialog()
{
    delete ui;
    // syslog( LOG_INFO, "Deleted About Dialog");
}

void MainAboutDialog::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void MainAboutDialog::on_pushButton_clicked()
{
    MainHelpDialog * dialog;

     dialog = new MainHelpDialog( this );

    // If Accepted => back button, then just close it.
    if (dialog->exec() ==  QDialog::Accepted)
    {
        syslog( LOG_INFO, "Help Window returning to About");
    }
    else
    {
        syslog( LOG_INFO, "Help Window returning to Main");

        // Just hide this window rather than close, because
        // it will return to the calling function and be
        // freed there.
        hide();
    }
    delete dialog;
}

void MainAboutDialog::on_pushButton_2_clicked()
{
    LegalInfoDialog * dialog;

    dialog = new LegalInfoDialog( this );

    // If Accepted => back button, then just close it.
    if (dialog->exec() ==  QDialog::Accepted)
    {
        syslog( LOG_INFO, "Help Window returning to About");
    }
    else
    {
        syslog( LOG_INFO, "Help Window returning to Main");

        // Just hide this window rather than close, because
        // it will return to the calling function and be
        // freed there.
        hide();
    }
    delete dialog;
}

void MainAboutDialog::on_closeButton_clicked()
{
    hide();
}
