// **************************************************************************************
// *
// * © 2012 Dell, Inc.
// * ALL RIGHTS RESERVED.
// *
// * Redistribution and use in source and binary forms, with or without modification, 
// * are permitted provided that the following conditions are met:
// * 
// *  *  Redistributions of source code must retain the above copyright notice, 
// *     this list of conditions and the following disclaimer.  
// * 
// *  *  Redistributions in binary form must reproduce the above copyright notice, 
// *     this list of conditions and the following disclaimer in the documentation 
// *     and/or other materials provided with the distribution.  
// * 
// *  *  Neither the name of Dell, Inc. nor the names of its contributors 
// *     may be used to endorse or promote products derived from this software 
// *     without specific prior written permission. 
// * 
// * 
// * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
// * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
// * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
// * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
// * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
// * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
// * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
// * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
// * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// * 
// **************************************************************************************

#ifndef SIMPLEADDFARMDIALOG_H
#define SIMPLEADDFARMDIALOG_H

#include <QDialog>
#include <QColor>
#include <QBitmap>
#include <CommonDialog/commonDialog.h>
#include <AutoConfigureDialog/autoconfiguredialog.h>
#include <LoadConfigurationDialog/loadConfigurationDialog.h>
#include "ManageConnectionDialog/manageConnectionDialog.h"

#include "farm.h"
#include "farmSettings.h"
#include "location.h"
#include "maskfactory.h"

namespace Ui {
    class SimpleAddFarmDialog;
}

class SimpleAddFarmDialog : public CommonDialog {
    Q_OBJECT
public:
    SimpleAddFarmDialog( FarmSettings* , QWidget *parent = 0 );
    ~SimpleAddFarmDialog();



protected:
    void changeEvent(QEvent *e);

private:
    Ui::SimpleAddFarmDialog *ui;

    FarmSettings* m_pFarmSettings;
    Farm* m_pCurrentFarm;
    QString m_currentFarmName;

    bool validateValues( void );
    bool initializeFarm( void );

private slots:
    void on_advancedViewButton_clicked();
    void on_connectButton_clicked();
    void on_autoConfigureButton_clicked();
    void on_cancelButton_clicked();
};

#endif // SIMPLEADDFARMDIALOG_H
