// **************************************************************************************
// *
// * © 2012 Dell, Inc.
// * ALL RIGHTS RESERVED.
// *
// * Redistribution and use in source and binary forms, with or without modification, 
// * are permitted provided that the following conditions are met:
// * 
// *  *  Redistributions of source code must retain the above copyright notice, 
// *     this list of conditions and the following disclaimer.  
// * 
// *  *  Redistributions in binary form must reproduce the above copyright notice, 
// *     this list of conditions and the following disclaimer in the documentation 
// *     and/or other materials provided with the distribution.  
// * 
// *  *  Neither the name of Dell, Inc. nor the names of its contributors 
// *     may be used to endorse or promote products derived from this software 
// *     without specific prior written permission. 
// * 
// * 
// * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
// * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
// * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
// * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
// * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
// * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
// * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
// * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
// * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// * 
// **************************************************************************************

#ifndef _FARM_SETTINGS_NAMES_
#define _FARM_SETTINGS_NAMES_

#include <QString>

// Application settings
const QString SHOW_STEPS = "ShowSteps";
const QString SHOW_CLICK_HERE = "ShowClickHere";


// Farm settings
const QString USERNAME = "Username";
const QString PASSWORD = "Password";
const QString DOMAIN_LIST = "DomainList";
const QString DOMAIN = "Domain";
const QString ALLOW_SAVE_CREDENTIALS = "AllowSaveCredentials";
const QString KERBEROS_MODE = "KerberosMode";
const QString KERBEROS_ENABLED = "KerberosEnabled";
const QString SSO_ENABLED = "SSOEnabled";

const QString WAIT_FOR_DESKTOP_ENABLED = "WaitForDesktopEnabled";
const QString WAIT_TIME = "WaitTime";
const QString NUMBER_OF_RETRIES = "NumberOfRetries";

const QString EXPERIENCE_LEVEL = "ExperienceLevel";
const QString ENABLE_WALLPAPER = "EnableWallpaper";
const QString ENABLE_FULL_WINDOW_DRAG = "EnableFullWindowDrag";
const QString ENABLE_ANIMATION = "EnableAnimation";
const QString ENABLE_THEMES = "EnableThemes";
const QString ENABLE_BITMAP_CACHING = "EnableBitmapCaching";
const QString MMR = "mmr";
const QString FMMR = "fmmr";
const QString GRAPHICS_ACCELERATION = "graphicsAccel";
const QString RECONNECT = "Reconnect";

const QString DISPLAY_CONNECTION_BAR = "DisplayConnectionBar";
const QString PIN_CONNECTION_BAR = "PinConnectionBar";

const QString SPAN_MONITORS = "SpanMonitors";
const QString SMART_SIZING = "SmartSizing";
const QString SEAMLESS_MODE = "SeamlessMode";
const QString REDIRECT_AUDIO = "RedirectAudio";
const QString REDIRECT_CLIPBOARD = "RedirectClipboard";
const QString REDIRECT_DRIVES = "RedirectDrives";
const QString REDIRECT_PRINTERS = "RedirectPrinters";
const QString REDIRECT_UNIVERSAL_PRINTERS = "RedirectUniversalPrinters";
const QString REDIRECT_COM_PORTS = "RedirecComPorts";
const QString REDIRECT_HANDHELDS = "RedirectHandhelds";
const QString REDIRECT_MICROPHONE = "RedirectMicrophone";
const QString REDIRECT_SMARTCARDS = "RedirectSmartCards";

const QString ENABLE_DOWNSTREAM_AUDIO = "EnableDownstreamAudio";
const QString DA_MODE = "DAMode";
const QString DA_QUALITY = "DAQuality";
const QString DA_BUFFERING = "DABuffering";
const QString DA_CUSTOM_QUALITY = "DACustomQuality";

const QString ENABLE_UPSTREAM_AUDIO = "EnableUpstreamAudio";
const QString UA_MODE = "UAMode";
const QString UA_QUALITY = "UAQuality";
const QString UA_COMPLEXITY = "UAComplexity";
const QString UA_ENHANCED_COMPRESSION = "UAEnhancedCompression";

const QString DESKTOP_WIDTH = "DesktopWidth";
const QString DESKTOP_HEIGHT = "DesktopHeight";
const QString COLOR_DEPTH = "ColorDepth";

const QString HIDE_SETTINGS = "HideSettings";

const QString ALLOW_PASSWORD_MANAGEMENT = "AllowPasswordManagement";
const QString PASSWORD_MANAGEMENT_PORT = "PasswordManagementPort";
const QString PASSWORD_MANAGEMENT_SERVER = "PasswordManagementServer";

const QString SOURCE_SERVER = "SourceServer";
const QString SOURCE_PROTOCOL = "SourceProtocol";
const QString SOURCE_FILE = "SourceFile";
const QString SOURCE_PROXY = "SourceProxy";

const QString AUTO_LAUNCH = "AutoLaunch";
const QString APPLICATIONS = "Applications";
const QString AUTO_CONNECT = "AutoConnect";
const QString NEED_RECONNECT = "NeedReconnect";

const QString ENABLE_DNA = "dnaproxy";

// Location settings
const QString LOCATION_SERVERS = "Servers";
const QString LOCATION_TCP_PORT = "TCPPort";
const QString LOCATION_PROTOCOL = "Protocol";
const QString LOCATION_NAT = "NAT";
const QString LOCATION_RDP_ON_SSL = "RDPonSSL";
const QString LOCATION_SSL_GATEWAY = "SSLGateway";
const QString LOCATION_PROXY_SERVER = "ProxyServer";
const QString LOCATION_PROXY_BYPASS_LIST = "ProxyBypassList";

const QString PROMPT_FOR_LOCATION = "PromptForLocation";
const QString DEFAULT_LOCATION = "DefaultLocation";
const QString LAST_LOCATION = "LastLocation";

#endif
