// **************************************************************************************
// *
// * © 2012 Dell, Inc.
// * ALL RIGHTS RESERVED.
// *
// * Redistribution and use in source and binary forms, with or without modification, 
// * are permitted provided that the following conditions are met:
// * 
// *  *  Redistributions of source code must retain the above copyright notice, 
// *     this list of conditions and the following disclaimer.  
// * 
// *  *  Redistributions in binary form must reproduce the above copyright notice, 
// *     this list of conditions and the following disclaimer in the documentation 
// *     and/or other materials provided with the distribution.  
// * 
// *  *  Neither the name of Dell, Inc. nor the names of its contributors 
// *     may be used to endorse or promote products derived from this software 
// *     without specific prior written permission. 
// * 
// * 
// * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
// * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
// * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
// * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
// * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
// * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
// * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
// * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
// * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// * 
// **************************************************************************************

#include "code.h"

// Cryption 256 code line
QString & encryptString256(const QString & source)
{
    QString *encryptedSource = new QString();

    const int bufferSize = 256;

    unsigned char buffer[bufferSize];
    char dest[(bufferSize + 1) * 2];
    ::Encode256(buffer, source.toLatin1().data());
    ::Encrypt(buffer, sizeof(buffer));
    ::BinToHex(buffer, sizeof(buffer), dest, sizeof(dest));

    *encryptedSource = dest;

    return *encryptedSource;
}

QString & decryptString256(const QString & source)
{
    QString *decryptedSource = new QString();

    const int bufferSize = 256;

    if (source.length() != bufferSize * 2)
        return *decryptedSource;

    unsigned char buffer[bufferSize + 2];
    char dest[bufferSize / 4];
    ::HexToBin(buffer, sizeof(buffer), source.toLatin1().data(), source.length());
    ::Decrypt(buffer, sizeof(buffer));
    ::Decode256(buffer, dest);

    *decryptedSource = dest;

    return *decryptedSource;
}

// Cryption 1024 code line
QString & encryptString1024(const QString & source)
{
    QString *encryptedSource = new QString();

    const int bufferSize = 1024;

    unsigned char buffer[bufferSize];
    char dest[(bufferSize + 1) * 2];
    ::Encode1024(buffer, source.toLatin1().data());
    ::Encrypt(buffer, sizeof(buffer));
    ::BinToHex(buffer, sizeof (buffer), dest, sizeof(dest));

    *encryptedSource = dest;

    return *encryptedSource;
}

QString & decryptString1024(const QString & source)
{
    QString *decryptedSource = new QString();

    const int bufferSize = 1024;

    if (source.length() != bufferSize * 2)
        return *decryptedSource;

    unsigned char buffer[bufferSize + 2];
    char dest[bufferSize / 4];
    ::HexToBin(buffer, sizeof(buffer), source.toLatin1().data(), source.length());
    ::Decrypt(buffer, sizeof(buffer));
    ::Decode1024(buffer, dest);

    *decryptedSource = dest;

    return *decryptedSource;
}

