#ifndef _QAUDIO_CODEC_H_
#define _QAUDIO_CODEC_H_

#define _FILE_OFFSET_BITS 64
#include <mpg123.h>

#include <speex/speex.h>
#include <speex/speex_stereo.h>


/*------------------------------speex encoder -----------------------------------------*/

typedef struct _speex_encoder
{
    WAVEFORMATEX format;
    void * encoder;

    short * data_buffer;
    uint32  data_buffer_size;

    SpeexBits bits;
} speex_encoder;


speex_encoder * codec_create ( LPWAVEFORMATEX format, int complexity, int quality );
void codec_destroy ( speex_encoder * codec );

uint32 codec_get_encoder_frame_bytes ( speex_encoder * codec );

uint32 codec_compress_buffer ( speex_encoder * codec , char * buffer , uint32 size , uint8 * out);

/*-------------------------------mp3 decoder------------------------------------------*/

struct _mp3decoder;

typedef int ( *pdecode ) (struct _mp3decoder * _decoder, unsigned char * _mp3, unsigned int _size , unsigned short * _out );

typedef struct _mp3decoder
{
    mpg123_handle * decoder;
    
    unsigned char data_buffer[ 16 ];
    unsigned int  start;
    unsigned int  end;


    pdecode decode;
    
} mp3decoder;


int mp3codec_initialize();
int mp3codec_uninitialize();

mp3decoder * mp3codec_create_decoder( int _rate , int _channels );
void mp3codec_destroy_decoder ( mp3decoder * _decoder );
int mp3codec_decode ( mp3decoder * _decoder, unsigned char * _mp3 , unsigned int _size, unsigned short * _out );



#endif
